
Ruby - Bug #8565

Compiled Regexp comparation bug

06/24/2013 04:32 PM - pyromaniac (Arkadiy Zabazhanov)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.0.0p195 (2013-05-14 revision

40734) [x86_64-darwin12.4.0]

Backport:  

Description

2.0.0p195 :001 > Regexp.new('/') == ///

=> false

There is no such problem in latest 1.9.3, expression return true

History

#1 - 06/24/2013 04:40 PM - Anonymous

I took a quick look at why this is happening. The equality fails because the source of the two regexps is different:

1.9.3:

Regexp.new('/').source

=> "\/"

///.source

=> "\/"

 

2.0.0:

Regexp.new('/').source

=> "\/"

///.source

=> "/"

 

#2 - 06/28/2013 05:36 AM - cedric.brancourt (Cedric Brancourt)

Hopefully this is not a bug (or I think it is not).

When you create new regexp with :

%r"/" and Regexp.new("/") your quote are the delimiters

when you create regexp with slashes /// the slashes (/) are your delimiters. Your regexp should end at the second / but fortunately you can escape

this one with a backslash.

So your backslash is there used to escape the second one. This mean that your regexp /// is equal to %r"/"

[6] pry(main)> /// == %r"/"

=> true

See http://www.ruby-doc.org/core-2.0/Regexp.html#label-Metacharacters+and+Escapes

#3 - 07/15/2019 01:24 AM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed

- Backport deleted (1.9.3: UNKNOWN, 2.0.0: UNKNOWN)
